/*

lcdnet: net status functions
Copyleft 1997 Andrew J. Kroll (ag784@freenet.buffalo.edu)

*/
#include "lcd.h"
long long ninet=0, nonet=0, oinet=0, oonet=0, tinet=1, tonet=1, tnet=0;

void netstattotal (long long *ip, long long *op)
{
  FILE *nf;
  long long j,k,l;
  char s_dv [12]="blow me";
  char ln [500];
  nf=fopen ("/proc/net/dev", "rt");
  fgets (ln, 500, nf);
  fgets (ln, 500, nf);
  *ip=0; *op=0;
  do {
#if LINUX_VERSION_CODE >= KERNEL_VER(2,2,0)
    /* grumble */
  /*  face |bytes packets errs drop fifo frame compressed multicast|bytes    packets errs drop fifo colls carrier compressed  */
fscanf (nf, "%8c%Lu %Lu %Lu %Lu %Lu %Lu %Lu %Lu %Lu %Lu %Lu %Lu %Lu %Lu %Lu %Lu",
	s_dv,&j,&k,&j,&j,&j,&j,&j,&j,&j,&l,&j,&j,&j,&j,&j,&j);
#else
    fscanf (nf, "%8c%Lu %Lu %Lu %Lu %Lu %Lu %Lu %Lu %Lu %Lu %Lu",s_dv, &k, &j, &j, &j, &j, &l, &j, &j, &j, &j, &j);
#endif
   (long long)*ip=(long long)*ip+k;
   (long long)*op=(long long)*op+l;
  } while(!feof(nf));

  fclose (nf);
}


void draw_net (int fd,int pass)
{
	netstattotal (&ninet, &nonet);

	/* input packets */
	tnet=ninet-oinet;
	tinet=+tnet;
	if (tinet > 10) tinet=10;
	if (tinet < 0 ) tinet=0;
	/* plot 0 - 10 pixels */
	tnet=tinet; /* holds how many segments to light, dynamic w/bandwidth */
	lcd_draw_bar(fd,tnet,33);
	lcd_draw_bar(fd,tnet,34);

	/* output packets */
	tnet=nonet-oonet;
	tonet=+tnet;
	if (tonet > 10) tonet=10;
	if (tonet < 0 ) tonet= 0;
	tnet=tonet; /* holds how many segments to light, dynamic w/bandwidth */
	lcd_draw_bar(fd,tnet,37);
	lcd_draw_bar(fd,tnet,38);

	/* values for next round */
	oinet=ninet; oonet=nonet;
	/* trim for different bandwidths, would a time index be better? */
	/* if(something) */ {
		tinet--;
		tonet--;
	}
	if (tinet<0) tinet=0;
        if (tonet<0) tonet=0;

}
